variables:
  DOCKER_CLI_EXPERIMENTAL: 'enabled'
  JOB_IMAGE: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/$CI_JOB_NAME:$CI_COMMIT_REF_NAME
  IMAGE_amd64: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/amd64:$CI_COMMIT_REF_NAME
  IMAGE_ppc64le: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/ppc64le:$CI_COMMIT_REF_NAME
  MANIFEST_IMAGE:  $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:$CI_COMMIT_REF_NAME
  APP_HELM_NAME: $CI_PROJECT_NAME

before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY

.docker-build:
  script:
    - docker build --build-arg GITLAB_LOGIN=gitlab-ci-token --build-arg GITLAB_PASSWORD=$CI_JOB_TOKEN --build-arg NPM_TOKEN=$NPM_TOKEN --pull -t $JOB_IMAGE -f $DOCKER_FILE .
    - docker push $JOB_IMAGE

.docker-build-test:
  script:
    - |
      [ -z $TARGET ] && export TARGET=builder
    - docker build --build-arg GITLAB_LOGIN=gitlab-ci-token --build-arg GITLAB_PASSWORD=$CI_JOB_TOKEN --build-arg NPM_TOKEN=$NPM_TOKEN --pull -t $JOB_IMAGE --target $TARGET -f $DOCKER_FILE .
    - docker run --rm $JOB_IMAGE $TEST_COMMAND

.npm-build:
  before_script:
    - npm config set '//registry.npmjs.org/:_authToken' $NPM_TOKEN
    - git config --global url."https://gitlab-ci-token:$CI_JOB_TOKEN@gitlab.com/".insteadOf "git@gitlab.com:"
    - echo '[http "https://gitlab.com"]' >> $HOME/.gitconfig
    - echo "  sslVerify = false"  >> $HOME/.gitconfig
  script:
    - npm install
    - npm run build
  image: $NPM_IMAGE

.yarn-build:
  before_script:
    - npm config set '//registry.npmjs.org/:_authToken' $NPM_TOKEN
    - git config --global url."https://gitlab-ci-token:$CI_JOB_TOKEN@gitlab.com/".insteadOf "git@gitlab.com:"
    - echo '[http "https://gitlab.com"]' >> $HOME/.gitconfig
    - echo "  sslVerify = false"  >> $HOME/.gitconfig
  script:
    - yarn install
    - yarn build
  image: $NPM_IMAGE

.manifest:
  tags:
    - amd64-docker
  script:
    - docker manifest create $MANIFEST_IMAGE $IMAGE_amd64 $IMAGE_ppc64le
    - docker manifest push $MANIFEST_IMAGE

.manifest-amd64:
  tags:
    - amd64-docker
  script:
    - docker manifest create $MANIFEST_IMAGE $IMAGE_amd64
    - docker manifest push $MANIFEST_IMAGE
